**Projekt Alumnihub**

**Lastenheft**

**Inhaltsverzeichnis**

- [Zweck des Dokumentes und Scope](#zweck-des-dokumentes-und-scope)
  - [Zweck des Dokumentes](#zweck-des-dokumentes)
  - [Scope und Abgrenzung](#scope-und-abgrenzung)
- [Grundlagen](#grundlagen)
  - [Verwendete Normen und mitgeltende Dokumente](#verwendete-normen-und-mitgeltende-dokumente)
- [Hardwareanforderungen](#hardwareanforderungen)
  - [Allgemeine Anforderunge](#allgemeine-anforderunge)
  - [Anforderungen an Server](#anforderungen-an-server)
  - [Anforderungen an den Bedienrechner / das mobile Endgerät](#anforderungen-an-den-bedienrechner--das-mobile-endgerät)
  - [Anforderungen an das Backup, Recovery und Desaster-Recovery](#anforderungen-an-das-backup-recovery-und-desaster-recovery)
  - [Anforderungen an Redundanz und Verfügbarkeit](#anforderungen-an-redundanz-und-verfügbarkeit)
    - [Redundanzeigenschaften](#redundanzeigenschaften)
    - [Verfügbarkeitsanforderungen](#verfügbarkeitsanforderungen)
  - [Schnittstellen](#schnittstellen)
    - [Schnittstellen zu eigenen Systemen](#schnittstellen-zu-eigenen-systemen)
    - [Schnittstellen zu anderen Systemen](#schnittstellen-zu-anderen-systemen)
- [Anforderungen an die Software](#anforderungen-an-die-software)
  - [Allgemeine Anforderungen](#allgemeine-anforderungen)
  - [Zugriffsverwaltung](#zugriffsverwaltung)
  - [Hall of Fame (Phase 2)](#hall-of-fame-phase-2)
  - [Firmen und Jobstellenmarkt (Phase 2)](#firmen-und-jobstellenmarkt-phase-2)
  - [Premiumbereich (Phase 2)](#premiumbereich-phase-2)
  - [Auswertungen](#auswertungen)
  - [Datenschutz \& Informationssicherheit](#datenschutz--informationssicherheit)
  - [Schwarzes Brett (Phase 2)](#schwarzes-brett-phase-2)
  - [Anmeldetool für Treffen](#anmeldetool-für-treffen)
  - [Profilverwaltung](#profilverwaltung)
- [Datenbank](#datenbank)
- [Dokumentation](#dokumentation)
  - [Projektdokumentation](#projektdokumentation)


# Zweck des Dokumentes und Scope

## Zweck des Dokumentes

*Der Zweck dieses Dokuments ist die Beschreibung der Anforderungen an die Hardware und an die Web-Anwendung für den Absolventenverband.*

*Das Ziel dieses Lastenhefts ist die detaillierte Beschreibung der Anforderungen an die zu entwickelnde Applikation für den Absolventenverband. Diese Applikation soll es ermöglichen, Absolventen zu verwalten, Veranstaltungen zu organisieren, eine Jobbörse zu integrieren und die Kommunikation innerhalb des Verbands zu verbessern. Dabei sollen verschiedene Rollen- und Berechtigungskonzepte berücksichtigt werden, und die Applikation soll in mehreren Phasen umgesetzt werden, wobei Funktionalitäten priorisiert werden.*

*Die Applikation soll eine zentrale Plattform für Absolventen sein, über die sie sich registrieren, austauschen und auf relevante Angebote zugreifen können. Kernkomponenten wie das Anmeldetool für Treffen, die Hall of Fame und der Jobstellenmarkt werden ergänzt durch optionale Funktionen wie die Integration von LinkedIn für Profilabgleiche und einen Premiumbereich für zahlende Nutzer.*

## Scope und Abgrenzung

*Abgrenzung / Was kommt in Phase 1 hinein?*

*Das Projekt umfasst die Entwicklung der Applikation mit den Funktionen für die Verwaltung von Absolventenprofilen, die Organisation von Veranstaltungen, die Darstellung der Hall of Fame, sowie die Integration eines Firmen- und Jobstellenmarkts. Die Zugriffsverwaltung sowie die Sicherheit der Daten (DSGVO-konform) sind wesentliche Bestandteile. Optional sind Erweiterungen wie ein Schülerzugang oder die Integration eines CMS für redaktionelle Beiträge. Nicht in den Scope fallen jedoch Zahlungsprozesse für den Premiumbereich und externe Lösungen für den Eventkalender (V-Calendar, V-Event), die separat betrachtet werden.*

# Grundlagen

## Verwendete Normen und mitgeltende Dokumente

*Die bestehenden Gesetze und technischen Regelwerke sind zu beachten. Insbesondere sind im Kontext des gegenständlichen Dokumentes die folgenden Normen zu berücksichtigen:*

*Die Applikation muss unter Beachtung der folgenden Normen und rechtlichen Vorgaben entwickelt werden:*

*- DSGVO (Datenschutz-Grundverordnung): Es dürfen nur notwendige personenbezogene Daten gespeichert werden, wie E-Mail, Telefonnummer und Land/Bundesland​. Ein Opt-In-Verfahren wird für die Speicherung von Nutzerdaten angewendet, und es muss die Möglichkeit zur Löschung von Einträgen geben (Rückwirkend möglich)*
*- NIS 2 Richtlinie (Netz- und Informationssicherheit); Als digitaler Dienstanbieter müssen Sicherheitsanforderungen eingehalten werden. Besonders die sichere Aufbewahrung und Verwaltung von Nutzerdaten, sowie der Schutz vor Datenverlust sind hier entscheidend​.*

*Weitere Bestimmungen, wie die Handhabung der Benutzerrechte und Datenschutzrichtlinien im Zusammenhang mit Drittanbieter-APIs (z. B. LinkedIn-OAuth), müssen ebenfalls geprüft und eingehalten werden.*

# Hardwareanforderungen

## Allgemeine Anforderunge

*Phase 2: Schülerzugang braucht mehr Nutzer…. Zugriffe / Tag steigen auch.*

| **300 aktuellen Nutzern**  <br>Das System muss mindestens 300 aktuelle Benutzer unterstützen, die das System administrieren, bearbeiten und nutzen können. Nicht jeder Benutzer benötigt ein eigenes Profil. | HW-1 |
| --- | --- |
| **ca. 50 Zugriffe / Tag**  <br>Das System muss in der Lage sein, ca. 50 aktive Benutzer pro Tag (tendenziell steigend) zu unterstützen, ohne dass die Systemleistung beeinträchtigt wird. Die Systemressourcen sollten ausreichend dimensioniert sein, um eine reibungslose und effiziente Nutzung durch die Benutzer zu gewährleisten. | HW-2 |
| **Einfach skalierbar**  <br>Das System muss einfach skaliert werden können, um aufsteigende Anforderungen und Benutzerzahlen reagieren zu können. Dies sollte ohne wesentliche Änderungen an der Systemarchitektur oder -Infrastruktur möglich sein, um eine flexible und kosteneffiziente Anpassung an zukünftige Bedürfnisse zu ermöglichen. | HW-3 |

## Anforderungen an Server

Phase 2: Schülerzugang braucht mehr Nutzer…. Zugriffe / Tag steigen auch.

<table><tbody><tr><th><p><strong>Die Anwendung wird auf einem Cloud-Server betrieben, der skalierbar ist, um den Anforderungen eines wachsenden Benutzerstamms gerecht zu werden.</strong></p></th><th><p>HW-4</p></th></tr><tr><td><p><strong>Hochverfügbar: 99.5%</strong></p><p>Das System muss eine Verfügbarkeit von mindestens 99,5% aufweisen. Dies bedeutet, dass das System innerhalb eines Jahres höchstens 43,8 Stunden (0,5% von 8760 Stunden) nicht verfügbar sein darf.</p></td><td><p>HW-5</p></td></tr><tr><td><p><strong>Datenbank und Anwendung muss redundant und gegen Ausfall eines Servers gesichert sein.</strong></p><p>Die Datenbank und die Anwendung müssen redundant und gegen Ausfälle gesichert sein, um Datenverluste und Systemausfälle zu vermeiden. Dies umfasst die Implementierung von:</p><ul><li>Datenbankreplikation</li><li>Regelmäßige Backups und Datenwiederherstellung</li></ul></td><td><p>HW-6</p></td></tr><tr><td><p><strong>.Net Runtime muss unterstützt werden</strong><br>Die Anwendung muss die .NET Runtime unterstützen, um eine reibungslose Ausführung von .NET-basierten Anwendungen zu ermöglichen.</p></td><td><p>HW-7</p></td></tr><tr><td><p><strong>Sicherheit und administrativer Zugriff:</strong></p><p>Der Zugriff auf die Anwendung und die Infrastruktur muss jederzeit gegeben sein. Dies kann durch die Implementierung von:</p><ul><li>SSH-Zugriff für Administratoren</li><li>VPN-Verbindung (Virtual Private Network) für eine sichere und verschlüsselte Verbindung</li><li>Zugriffskontrolle und Authentifizierung, um den Zugriff auf autorisierte Personen zu beschränken</li></ul><p>erreicht werden.</p></td><td><p>HW-8</p></td></tr></tbody></table>

## Anforderungen an den Bedienrechner / das mobile Endgerät

| **Moderner Browser (Chrome, Firefox, Safari und Edge)** | HW-9 |
| --- | --- |
| **JavaScript muss aktiv sein.** | HW-10 |
| **Internetverbindung (5 MBit/s)** | HW-11 |

## Anforderungen an das Backup, Recovery und Desaster-Recovery

| **Automatisierte Datensicherung**<br><br>Zur Erhöhung der Datensicherheit soll über das Komplettsystem eine automatisierte Datensicherung erfolgen. (Versionen / Binaries der Anwendungen, Konfigurationsdateien und Nutzerdaten) | HW-12 |
| --- | --- |
| **Wiederherstellungszeitraum**<br><br>Die Wiederherstellung des Servers im Falle eines Ausfalls (des Rechenzentrums) muss innerhalb von **einem Tag** gewährleistet sein. Also nach 24 Stunden muss das System wieder in einen benutzbaren Zustand gebracht werden | HW-13 |
| **Dokumentation zum Wiederherstellungsverfahren muss vorhanden sein.**<br><br>Schritt für Schritt Anweisungen zum Wiederherstellen des Systems | HW-14 |

## Anforderungen an Redundanz und Verfügbarkeit

### Redundanzeigenschaften

Redundanzeigenschaften Bespr. Mit Hr. Prof. Gürth

|     | RED-1 |
| --- | --- |
|     | RED-2 |
|     | RED-3 |

### Verfügbarkeitsanforderungen

| **99% / Jahr (87.6h)**<br><br>Das System soll weniger als 90 Stunden im Jahr ausfallen. | RED-4 |
| --- | --- |
| **Wiederherstellungszeit: the next business day**<br><br>Das System soll bis zum übernächsten Werktag wieder in einen Nutzbaren zustand bringbar sein. | RED-5 |
|     |     |

## Schnittstellen

### Schnittstellen zu eigenen Systemen

| Anforderung | ID |
| --- | --- |
| RestAPI (Frontend / Backend)<br><br>1. Zielsetzung <br>Die geplante REST API soll in die Oqtane-CMS-Umgebung integriert werden, um eine dynamische Kommunikation zwischen dem CMS und einer Website zu ermöglichen. Sie dient dazu, Inhalte und Funktionen des CMS über die API für die Website verfügbar zu machen und ermöglicht dynamische CRUD-Operationen (Create, Read, Update, Delete) direkt aus dem CMS heraus.<br><br>2. Aufgabenbeschreibung<br>Die Aufgabe umfasst:<br>Integration in Oqtane: Erweiterung des Oqtane-CMS mit zusätzlichen Modulen und APIs.<br>Entwicklung der REST API: Bereitstellung von Endpunkten zur Interaktion zwischen CMS-Daten und Website.<br>Frontend-Integration: Anbindung der Website an die API, um CMS-Inhalte dynamisch darzustellen.<br>Sicherheitsimplementierung: Absicherung der API und des Datenflusses zwischen CMS und Website.<br><br>3. Sicherheitsanforderungen<br>Authentifizierung:<br>Verwendung von Oqtane's integriertem Benutzermanagement und JWT für Authentifizierung.<br>Sicherstellung, dass Benutzerrollen (z. B. Admin, Editor, User) berücksichtigt werden.<br>Autorisierung:<br>Zugriff auf Endpunkte wird basierend auf Benutzerrollen gesteuert.<br>Sensible Aktionen (z. B. Inhalte löschen) nur für berechtigte Benutzer möglich.<br>Eingabedatenvalidierung:<br>Eingaben im Frontend und Backend validieren.<br>API-Schutz:<br>Schutz gegen CSRF, XSS, und andere Angriffe.<br>Nutzung von HTTPS.<br><br>4. Nicht-funktionale Anforderungen<br>Performance: Antwortzeiten der API < 300ms für häufige Anfragen.<br>Kompatibilität: Vollständig kompatibel mit Oqtane-Modulen und Standard-Datenstrukturen.<br>Skalierbarkeit: Möglichkeit, neue Module und API-Endpunkte ohne größere Umbauten zu integrieren.<br>Internationalisierung: Unterstützung mehrsprachiger Inhalte.<br><br>5. Technische Umsetzung<br>5.1. Backend (Oqtane CMS)<br>Framework: ASP.NET Core, integriert in Oqtane.<br>Architektur:<br>Erweiterung des Oqtane-CMS durch Module.<br>Nutzung der Oqtane-Service-API und Datenzugriff über die vorhandene Architektur.<br>Erstellung benutzerdefinierter APIs mit .Controllers und Abbildung auf Oqtane-Tabellen.<br>5.2. Frontend<br>Technologien:<br>JavaScript-Frameworks wie React, Angular oder Vue.js.<br>Integration der REST API über Bibliotheken wie Axios oder die Fetch API.<br>Darstellung der Inhalte aus Oqtane in dynamischen Komponenten (z. B. Listen, Detailansichten).<br>API-Integration:<br>Frontend ruft Inhalte direkt von der REST API ab.<br>Dynamische Aktualisierung der Inhalte durch Benutzeraktionen (z. B. Formularübermittlung).<br>5.3. Sicherheit<br>Authentifizierung:<br>Authentifizierung über JWT-Token (Login-Endpunkte in Oqtane).<br>Speicherung von Token im sicheren Speicher (z. B. HttpOnly Cookies).<br>Eingabeverarbeitung:<br>Validierung von Daten im Frontend und Backend.<br>Schutz vor schädlichen Nutzereingaben (z. B. SQL-Injection).<br><br>6. Erfolgskriterien<br>Die Website kann nahtlos mit der Oqtane-REST API interagieren.<br>Die API erfüllt alle funktionalen Anforderungen und ist in die Oqtane-Datenstruktur integriert.<br>Sichere und performante Bereitstellung der API.<br>Modularer Aufbau, der zukünftige Erweiterungen unterstützt.<br><br> | SnT-1 |

### Schnittstellen zu anderen Systemen

| Anforderung | ID |
| --- | --- |
| SMTP (Email versand)<br><br>1. Zielsetzung<br>Die Implementierung eines SMTP-basierten E-Mail-Versands in der C#-Backend-Anwendung ermöglicht das Versenden von E-Mails über einen konfigurierten<br> Mailserver. Dies umfasst sowohl systemgenerierte E-Mails (z. B. Bestätigungen, Benachrichtigungen) als auch benutzergenerierte Inhalte.<br>Das Ziel ist eine zuverlässige, sichere und skalierbare Lösung für den E-Mail-Versand.<br><br>2. Aufgabenbeschreibung<br>Die Aufgabe umfasst:<br>Konfiguration des SMTP-Servers: Festlegung von Parametern wie Host, Port, Authentifizierung und Verschlüsselung.<br>Erstellung von E-Mail-Nachrichten: Gestaltung der E-Mails im Text- und HTML-Format.<br>Integration in die C#-Backend-Anwendung: Nutzung von SMTP-Befehlen über .NET-Bibliotheken.<br>Fehlerbehandlung und Logging: Sicherstellung eines robusten Versandprozesses und Nachverfolgung fehlerhafter E-Mails.<br>Sicherheitsmaßnahmen: Schutz der E-Mail-Kommunikation und Verhinderung von Missbrauch.<br><br>3. Dynamischer Versand<br>Benachrichtigungs-E-Mails:<br>Beispiele: Willkommens-E-Mails, Passwort-Zurücksetzen, Bestellbestätigungen.<br>Dynamische Platzhalter (z. B. {Name}, {Bestellnummer}) für personalisierte Inhalte.<br>Massen-E-Mails:<br>Versand an mehrere Empfänger (z. B. Newsletter).<br>Nutzung von BCC oder sequentiellem Versand.<br>3.1 Fehler- und Zustellungsmanagement<br>Protokollierung von fehlgeschlagenen E-Mails (z. B. ungültige Adresse, Verbindung zum SMTP-Server fehlgeschlagen).<br>Rückmeldung an die Anwendung, wenn der Versand erfolgreich war.<br>Möglichkeit zur späteren Wiederholung fehlgeschlagener E-Mails.<br><br>4. Nicht-funktionale Anforderungen<br>Performance:<br>E-Mails sollen innerhalb von 3 Sekunden pro Nachricht versendet werden.<br>Unterstützung von mindestens 100 gleichzeitigen E-Mails bei Massenversand.<br>Skalierbarkeit:<br>Vorbereitung auf den Versand von bis zu 10.000 E-Mails pro Tag.<br>Sicherheit:<br>Verschlüsselung der Verbindung zum SMTP-Server (TLS/SSL).<br>Schutz vor Spam und Missbrauch (z. B. Rate-Limiting).<br>Kompatibilität:<br>Unterstützung moderner E-Mail-Clients (z. B. Gmail, Outlook, Thunderbird).<br>Sicherstellung der Anzeige von HTML-E-Mails auf Desktop- und Mobilgeräten.<br><br>5. Technische Umsetzung<br>5.1. Backend<br>Framework: ASP.NET Core.<br>Bibliotheken:<br>Verwendung von .NET System.Net.Mail oder externen Bibliotheken wie MailKit oder FluentEmail für erweiterten SMTP-Support.<br>Architektur:Erstellung eines SMTP-Services:Methoden für das Versenden von einfachen und komplexen E-Mails.Unterstützung für Anhänge und Templates.<br><br>5.2. Sicherheit<br>Schutz der Zugangsdaten:<br>Verwendung eines Secret Managers oder von Umgebungsvariablen für SMTP-Zugangsdaten.<br>Rate Limiting:<br>Begrenzung der Anzahl der E-Mails pro Zeitspanne, um Serverüberlastung zu vermeiden.<br>Spam-Prävention:<br>Konfiguration von SPF, DKIM und DMARC auf der Mailserver-Seite.<br><br>6. Erfolgskriterien<br>Alle E-Mails werden zuverlässig und sicher über den SMTP-Server versendet.<br>Personalisierte Nachrichten und Anhänge werden korrekt verarbeitet.<br>Robustheit gegen typische Fehler und Schutz vor Missbrauch.<br><br>| SnT-2 |
| LinkedÌn OAuth (Phase 2, oder später)<br><br>Backend zu LinkedIn<br><br>1. Zielsetzung<br>Implementierung von LinkedIn OAuth 2.0 für die Authentifizierung und den Abruf von Profildaten in der C#-Backend-Anwendung.<br><br>2. Anforderungen<br>Registrierung der App im LinkedIn Developer Portal.<br>OAuth 2.0 Authentifizierungsablauf:<br>Weiterleitung zur LinkedIn-Login-Seite.<br>Empfang des Autorisierungscodes.<br>Austausch des Codes gegen ein Zugriffstoken.<br>Abruf von Benutzerinformationen (Vorname, Nachname, E-Mail).<br>Sicheres Token-Management (kein Speichern von Zugangsdaten in der Datenbank).<br><br>3. Technische Umsetzung<br>Backend: ASP.NET Core<br>API-Endpunkte:<br>/auth/linkedin (Weiterleitung zur LinkedIn-Login-Seite).<br>/auth/linkedin/callback (Empfang des Codes).<br>/api/user/profile (Abruf von LinkedIn-Daten mit Token).<br>Sicherheit:<br>Nutzung von HTTPS und PKCE.<br>Speicherung von Tokens nur im Cache (z. B. Redis).<br>Einschränkung der API-Berechtigungen (r_liteprofile, r_emailaddress).<br><br>4. Erfolgskriterien<br>Benutzer können sich sicher über LinkedIn anmelden.<br>Zugriffstoken werden sicher verarbeitet.<br>API-Datenabruf funktioniert zuverlässig.<br> | SnT -3 |

# Anforderungen an die Software

## Allgemeine Anforderungen

| Die Website oder Webanwendung wird so entwickelt, dass sie in den aktuellen und vorherigen Versionen der gängigsten Webbrowser einwandfrei funktioniert: </p><p> Google Chrome (Desktop und Mobile) <br>Mozilla Firefox (Desktop und Mobile)<br>Safari (macOS und iOS)<br>Microsoft Edge (Chromium-basiert)</p><p> 1. Programmiersprachen und Standards: <br> -Die Entwicklung erfolgt auf Basis moderner Technologien wie HTML5, CSS3 für eine plattformübergreifende Funktionalität.</p><p> 2. Frameworks und Bibliotheken: <br> -Frameworks wie React, Angular oder Vue.js (für die Frontend-Entwicklung) sowie CSS-Frameworks wie Bootstrap oder TailwindCSS können zum Einsatz kommen.</p><p> 3. Build-Tools: <br> -Tools wie Webpack, Vite oder Parcel werden zur Optimierung der Assets (z. B. Minifizierung und Bundling von Dateien) verwendet,um die Performance auf verschiedenen Browsern zu gewährleisten. <br><br> | SW-1 |



| Barrierefreiheit (WAI-ARIA-Standard) ...</p><p> <b> 1. Verwendung von ARIA-Attributen: </b> <br> -Semantik und Bedienbarkeit durch role, aria-label, aria-expanded, aria-live etc. verbessern.<br>-Dynamische Inhalte und interaktive Elemente mit Attributen wie aria-controls oder aria-describedby ausstatten. </p><p> <b> 2. Technologien und Tools:</b> <br>-Unterstützung durch Frameworks (z. B. React, Angular) und CSS-Frameworks (z. B. Bootstrap). <br>-Einsatz von Tools wie Axe, Lighthouse oder eslint-plugin-jsx-a11y zur Validierung. </p><p> <b> 3. Tastaturbedienbarkeit und Kontraste:</b> <br>-Sicherstellen, dass alle Inhalte per Tastatur erreichbar sind.<br> -Einhalten der Kontrastvorgaben gemäß WCAG 2.1 Stufe AA. <br><br> | SW-2 |

| **CMS**: <br>Das System soll einen redaktionellen Schülerzugagng bieten, damit die Diplomarbeiten von Schülern selbst eingepflegt werden können. | SW-3 |

## Zugriffsverwaltung

<table>
<tbody>
<tr><th>
<p><strong>Benutzername und Passwort Authentifizierung</strong></p>
<p>Frontend:</p>
<p>Benutzername- und Passwort-Authentifizierung auf die Interaktion des Benutzers mit der Weboberfläche. Es geht darum, wie der Benutzer seine Anmeldeinformationen eingibt, wie diese Daten sicher an den Server übermittelt werden und wie der Benutzer nach erfolgreicher Authentifizierung auf die geschützten Teile der Anwendung zugreifen kann.</p>
<p>Backend:</p>
<p>Überprüft die empfangenen Anmeldedaten, in dem er nach vorhandenen Benutzernamen sucht. Anschließend wird das eingegebene Passwort mit den Daten in der Datenbank überprüft.</p>
</th>
<th><p>ZUG-1</p></th></tr>
<tr><td><p><strong>Passwort zurücksetzen</strong></p>
<p>Frontend:</p>
<p>Das Zurücksetzen des Passworts im
<strong> Frontend </strong>
einer Anwendung ermöglicht es den Benutzern, ihr Passwort zu ändern, falls sie es vergessen haben oder aus anderen Gründen ein neues Passwort festlegen möchten.</p>
<p>Backend:</p>
<p>Passwortreset-Funktion: Benutzer können ihre E-Mail-Adresse eingeben, um einen Passwortreset anzufordern.
E-Mail-Versand: Die Anwendung sendet einen Link mit einem einmaligen, zeitlich begrenzten Token an die angegebene E-Mail-Adresse.
Sicherheitsanforderungen: Der Token muss sicher generiert werden, und der Link darf keine sensiblen Informationen enthalten.
Benutzeroberfläche: Die Oberfläche für den Passwortreset muss benutzerfreundlich sein und eine Bestätigung anzeigen.
Datenbankoperationen: Der neue Passwort-Hash wird in der Datenbank gespeichert und überschreibt den alten Eintrag.
Fehlerbehandlung: Geeignete Fehlermeldungen müssen angezeigt werden, wenn die E-Mail nicht registriert ist oder der Token abgelaufen ist.
Protokollierung: Alle Passwortreset-Anfragen müssen protokolliert werden.</p></td>
<td><p>ZUG-2</p></td></tr>
<tr><td><p><strong>Rollen</strong></p>
<p>Frontend:</p>
<p>Verwaltung von Benutzerrechten und Zugriffssteuerung innerhalb einer Webanwendung. In einer typischen Anwendung können Benutzer unterschiedliche Rollen haben, die bestimmte Berechtigungen definieren. Diese Rollen beeinflussen, welche Teile der Anwendung für den Benutzer sichtbar sind oder welche Aktionen er ausführen darf.</p>
<p>Backend:</p>
<p>DRollendefinition:
Definieren von Rollen (z.B. Administrator, Benutzer, Gast) mit spezifischen Berechtigungen.
Datenbankstruktur:
Entwurf einer Datenbanktabelle zur Speicherung von Rollen und deren Berechtigungen.
Rollenvergabe:
Implementierung von Funktionen zur Zuweisung und Entziehung von Rollen an Benutzer im Backend.
Berechtigungsprüfung:
Entwicklung einer Middleware oder Funktion, die bei jeder Anfrage überprüft, ob der Benutzer die erforderlichen Berechtigungen für die angeforderte Aktion hat.
Sicherheitsanforderungen:
Sicherstellen, dass nur autorisierte Benutzer (z.B. Administratoren) Rollen ändern oder zuweisen können.
Protokollierung:
Implementierung von Protokollierungsmechanismen für Änderungen an Rollen und Berechtigungen zur Nachverfolgbarkeit.</p></td>
<td><p>ZUG-3</p></td></tr>
<tr><td><p><strong>Benutzerverwaltung (für Admins)</strong></p>
<p>Frontend:</p>
<p>Die Benutzerverwaltung für Administratoren in einer Webanwendung bezieht sich auf die Funktionen, die es Administratoren ermöglichen, Benutzerkonten zu erstellen, zu bearbeiten, zu löschen und deren Berechtigungen zu verwalten.</p>
<p>Backend:</p>
<p>Datenbankoperationen:
Alle Änderungen, die über die Weboberfläche im Admin-Bereich vorgenommen werden, müssen über definierte Backend-API-Endpunkte in der Datenbank gespeichert werden.
Zugriffssteuerung:
Implementierung einer strengen Zugriffssteuerung, die sicherstellt, dass nur autorisierte Benutzer (z.B. Administratoren) Änderungen vornehmen können.
Berechtigungsprüfung:
Vor jeder Datenbankoperation muss eine Überprüfung der Benutzerrollen und -berechtigungen erfolgen, um sicherzustellen, dass der Benutzer die erforderlichen Rechte hat.
Validierung der Eingaben:
Alle Eingaben, die über die Weboberfläche an das Backend gesendet werden, müssen validiert werden, um sicherzustellen, dass sie den erwarteten Formaten und Werten entsprechen.
Protokollierung von Änderungen:
Alle Änderungen, die im Admin-Bereich vorgenommen werden, müssen protokolliert werden, um eine Nachverfolgbarkeit und Auditierung zu ermöglichen.
Sicherheitsmaßnahmen:
Implementierung von Sicherheitsmaßnahmen wie Rate Limiting und IP-Whitelisting, um unbefugte Zugriffe zu verhindern.
Fehlerbehandlung:
Bereitstellung von klaren Fehlermeldungen und Handhabung von unerwarteten Situationen, um die Integrität der Daten zu gewährleisten.</p></td>
<td><p>ZUG-4</p></td></tr>
<tr><td><p><strong>Einladung an die EDU-Adresse (Phase 2)</strong></p>
<p>Frontend:</p>
<p>Im Frontend können Benutzer Einladungen an E-Mail-Adressen versenden, indem sie eine Adresse in ein Eingabefeld eingeben und auf „Einladen“ klicken. Die Anwendung überprüft die E-Mail-Adresse und sendet sie dann an das Backend, das eine Einladung generiert und per E-Mail verschickt.</p>
<p>Backend:</p>
<p>Einladungserstellung:
Implementierung einer Funktion zur Erstellung einer Einladung, die alle erforderlichen Informationen (z.B. Empfänger, Betreff, Nachricht, Datum, Uhrzeit) erfasst.
Datenbankintegration:
Speichern der Einladung in der Datenbank, einschließlich aller relevanten Details und des Status (z.B. erstellt, versendet).
E-Mail-Vorlage:
Erstellung einer E-Mail-Vorlage, die die Einladung in einem ansprechenden Format darstellt.
E-Mail-Versand:
Implementierung einer Funktion, die die Einladung per E-Mail an den vorgesehenen Empfänger sendet, einschließlich der Verwendung eines E-Mail-Dienstes (z.B. SMTP-Server).
Berechtigungsprüfung:
Sicherstellen, dass nur autorisierte Benutzer (z.B. Administratoren) Einladungen erstellen und versenden können.
Fehlerbehandlung:
Implementierung von Mechanismen zur Fehlerbehandlung, um sicherzustellen, dass der Benutzer über den Erfolg oder das Scheitern des E-Mail-Versands informiert wird.
Protokollierung:
Protokollierung aller Einladungen, die erstellt und versendet wurden, um eine Nachverfolgbarkeit zu gewährleisten.
Eingabever validation:
Validierung der Eingaben (z.B. E-Mail-Adresse, Datum) vor der Erstellung und dem Versand der Einladung, um sicherzustellen, dass sie korrekt sind.</p></td>
<td><p>ZUG-5</p></td></tr>
<tr><td><p><strong>Magic Link Authentifizierung</strong></p>
<p>Frontend:</p>
<p>Die Magic Link Authentifizierung ist eine Methode der Benutzeranmeldung, bei der anstelle eines Passworts ein einmaliger Login-Link an die E-Mail-Adresse des Benutzers gesendet wird. Wenn der Benutzer auf diesen Link klickt, wird er automatisch und sicher in die Anwendung eingeloggt.</p>
<p>Backend:</p>
<p>Benutzerregistrierung::
Implementierung einer Funktion zur Registrierung potenzieller Benutzer, die ihre E-Mail-Adresse und andere erforderliche Informationen erfasst.
E-Mail-Versand:
Nach der Registrierung muss eine E-Mail an die angegebene Adresse gesendet werden, die einen Authentifizierungslink enthält.
Link-Generierung:
Der Authentifizierungslink muss einen einmaligen, kryptografisch sicheren Token enthalten, der mit dem Benutzerkonto verknüpft ist und eine begrenzte Gültigkeitsdauer hat (z.B. 24 Stunden).
Datenbankeintrag:
Der Token und der Status der Authentifizierung müssen in der Datenbank gespeichert werden, um die Gültigkeit des Links zu überprüfen.
Link-Verifizierung:
Implementierung einer Funktion, die den Token überprüft, wenn der Benutzer auf den Link klickt, um sicherzustellen, dass er gültig und nicht abgelaufen ist.
Benutzeraktivierung:
Nach erfolgreicher Verifizierung des Tokens muss das Benutzerkonto aktiviert werden, und der Benutzer sollte auf eine Bestätigungsseite weitergeleitet werden.
Fehlerbehandlung:
Bereitstellung von klaren Fehlermeldungen, wenn der Token ungültig oder abgelaufen ist, und gegebenenfalls die Möglichkeit zur erneuten Anforderung des Authentifizierungslinks.
Protokollierung:
Protokollierung aller Authentifizierungsanfragen und -versuche, um eine Nachverfolgbarkeit zu gewährleisten.</p></td>
<td><p>ZUG-6</p></td></tr>
<tr><td><p><strong>2FA Authentifizierung (Phase 2)</strong></p>
<p>Frontend:</p>
<ul><li>Erste Anmeldung: Der Benutzer gibt seinen Benutzernamen und sein Passwort im Frontend ein.</li>
<li>2FA-Code-Anforderung: Nach erfolgreicher Passworteingabe fordert die Anwendung einen zweiten Faktor an, z. B. einen 6-stelligen Code, der per SMS, E-Mail oder einer Authenticator-App (z. B. Google Authenticator) generiert wird.</li>
<li>Code-Eingabe: Der Benutzer gibt den Code im Frontend ein.</li>
<li>Verifizierung: Das Frontend sendet den Code zur Verifizierung an das Backend.</li>
<li>Zugriff gewähren: Bei korrekter Codeeingabe erhält der Benutzer Zugriff auf die Anwendung.</li></ul>
<p>Backend:</p>
<p>Anmeldedatenüberprüfung:
Nach der Eingabe der Anmeldedaten (Benutzername und Passwort) muss das System die Anmeldedaten validieren und überprüfen.
Code-Generierung:
Implementierung einer Funktion zur Generierung eines zeitlich begrenzten Codes (z.B. TOTP - Time-based One-Time Password), der auf einem anderen Gerät (z.B. Smartphone) generiert wird.
Code-Übermittlung:
Der generierte Code muss über eine sichere Kommunikationsoberfläche (z.B. Push-Benachrichtigung, SMS oder E-Mail) an den Benutzer gesendet werden.
Benutzereingabe:
Der Benutzer muss die Möglichkeit haben, den erhaltenen Code in die Anmeldemaske einzugeben, um seine Identität zu bestätigen.
Code-Überprüfung:
Implementierung einer Funktion zur Überprüfung des eingegebenen Codes gegen den generierten Code, um sicherzustellen, dass er korrekt und innerhalb der Gültigkeitsdauer ist.
Fehlerbehandlung:
Bereitstellung von klaren Fehlermeldungen, wenn der eingegebene Code ungültig oder abgelaufen ist, sowie die Möglichkeit, einen neuen Code anzufordern.
Sicherheitsanforderungen:
Sicherstellen, dass die Kommunikation zwischen dem Server und dem Gerät des Benutzers sicher ist (z.B. durch Verschlüsselung).
Protokollierung:
Protokollierung aller Anmeldeversuche und der Verwendung von Codes zur Nachverfolgbarkeit und zur Erkennung von potenziellen Sicherheitsvorfällen.</p></td>
<td><p>ZUG-7</p></td></tr>
<tr><td><p><strong>OAuth (Phase 2)</strong></p>
<p>Frontend:</p>
<ul><li><strong>Anmeldelink</strong>
: Der Benutzer klickt auf einen Login-Button, und das Frontend leitet ihn zur OAuth-Provider-Seite (z. B. Google) weiter.</li>
<li><strong>Autorisierung</strong>
: Der Benutzer meldet sich an und erlaubt der Anwendung Zugriff auf bestimmte Daten.</li>
<li><strong>Token-Erhalt</strong>
: Der OAuth-Provider leitet den Benutzer zurück zur Anwendung mit einem Access Token in der URL.</li>
<li><strong>API-Zugriff</strong>
: Das Frontend speichert das Token (meist im Speicher des Browsers) und verwendet es, um direkt auf API-Ressourcen zuzugreifen.</li></ul>
<p>Backend:</p>
<p>OAuth 2.0 Integration:
Implementierung des OAuth 2.0-Protokolls zur Authentifizierung über LinkedIn. Dies umfasst die Registrierung der Anwendung bei LinkedIn und den Erhalt der erforderlichen Client-ID und Client-Secret.
Benutzeranmeldung:
Bereitstellung eines Endpunkts, über den Benutzer sich mit ihrem LinkedIn-Account anmelden können. Dies sollte einen Redirect zur LinkedIn-Login-Seite und die anschließende Rückleitung zur eigenen Anwendung nach erfolgreicher Authentifizierung umfassen.
Token-Verwaltung:
Nach erfolgreicher Authentifizierung muss das Backend den von LinkedIn erhaltenen Access-Token speichern, um zukünftige Anfragen an die LinkedIn-API zu ermöglichen.
Mapping von LinkedIn-Accounts:
Implementierung einer Datenbanktabelle, die das Mapping zwischen LinkedIn-Accounts (z.B. LinkedIn-ID) und den internen Benutzerkonten in der eigenen Anwendung speichert.
Profilabgleich (Zukünftige Ausbaustufe):
In einer späteren Phase sollte eine Funktion implementiert werden, die es ermöglicht, das LinkedIn-Profil des Benutzers abzurufen und mit dem eigenen Benutzerprofil abzugleichen. Dies könnte Informationen wie Name, E-Mail-Adresse, Berufserfahrung und Fähigkeiten umfassen.
Sicherheitsanforderungen:
Sicherstellen, dass alle Daten, die von LinkedIn abgerufen werden, sicher gespeichert und verarbeitet werden, um die Privatsphäre der Benutzer zu schützen.
Fehlerbehandlung:
Implementierung von Mechanismen zur Fehlerbehandlung, um mit möglichen Problemen bei der Authentifizierung oder beim Abrufen von Daten von LinkedIn umzugehen.
Protokollierung:
Protokollierung aller Authentifizierungsversuche und der zugehörigen LinkedIn-Daten, um eine Nachverfolgbarkeit und Analyse von Anmeldeaktivitäten zu ermöglichen.</p></td>
<td><p>ZUG-8</p></td></tr></tbody></table>

## Hall of Fame (Phase 2)

| PDF-Generierung<br><br>Frontend:  <br>Das System muss eine PDF-Generierung im Frontend der Hall of Fame für Treffen ermöglichen. Nutzer sollen ihre persönlichen Erfolge in einem ansprechenden Dokument festhalten können. Jedes PDF soll ein Bild der Person sowie eine Übersicht über ihre Schullaufbahn, berufliche Stationen und besondere Leistungen enthalten. Diese Dokumente sollen anschließend ausgedruckt und zur Präsentation verwendet werden können. | HoF-1 |
| --- | --- |
| Online Hall of Fame<br><br>Frontend:  <br>Das System muss eine Online Hall of Fame im Frontend bereitstellen, die es Nutzern ermöglicht, ihre Erfolge und besonderen Leistungen zu präsentieren. Diese Plattform soll eine ansprechende und motivierende Darstellung von Nutzerbeiträgen bieten, sodass herausragende Leistungen sichtbar gemacht und gewürdigt werden können. | HoF-2 |
| OptIn Modell für Benutzer<br><br>Frontend:  <br>Das System muss ein Opt-In-Modell im Frontend der Hall of Fame für Treffen bereitstellen, das es Nutzern ermöglicht, aktiv zu entscheiden, ob sie in die Ruhmeshalle aufgenommen werden möchten. Durch eine einfache Zustimmung können Nutzer ihre Erfolge und Beiträge sichtbar machen, während sie gleichzeitig die Kontrolle über ihre Daten behalten und sicherstellen, dass nur die gewünschten Informationen geteilt werden. | HoF-3 |
| Löschantrag<br><br>Frontend:  <br>Das System muss ein Opt-In-Modell im Frontend der Hall of Fame für Treffen bereitstellen, das es Nutzern ermöglicht, aktiv zu entscheiden, ob sie in die Ruhmeshalle aufgenommen werden möchten. Durch eine einfache Zustimmung können Nutzer ihre Erfolge und Beiträge sichtbar machen, während sie gleichzeitig die Kontrolle über ihre Daten behalten und sicherstellen, dass nur die gewünschten Informationen geteilt werden. | HoF-4 |

## Firmen und Jobstellenmarkt (Phase 2)

| Agenturschnittstellen (API & GUI) | JOB-1 |
| --- | --- |
| Job / Mitarbeiterbörse / Praktikabörse | JOB-2 |
| Privatsphäre Einstellungen | JOB-3 |

## Premiumbereich (Phase 2)

| <b>Verwaltung der Premiumkunden</b> </p><p> 1. Benutzerverwaltung:<br>  - Identifikation und Segmentierung der Premiumkunden.<br> -Erstellung und Verwaltung individueller Kundenprofile.<b> <p/><p> 2. Serviceverwaltung: <br> -Bereitstellung maßgeschneiderter Dienstleistungen und Angebote. <br> -Exklusive Inhalte oder Angebote für Premiumkunden.<br> </p><p> 3. Kommunikationssystem:<b> -Regelmäßige und personalisierte Kommunikation über E-Mail, Push-Benachrichtigungen oder Messaging-Dienste.<b> 4. Feedback- und Zufriedenheitstools:<b> -Sammlung von Kundenfeedback <br> -Tools zur Überwachung und Analyse der Kundenzufriedenheit.</p><p> Technologien: <br> -Datenbank:  MySQL, PostgreSQL oder MongoDB zur Speicherung von Kundeninformationen und Präferenzen.<br>  -CRM-System: Salesforce, HubSpot oder eine Eigenentwicklung zur Kundenverwaltung.<br>  -Kommunikation: SMTP (z. B. SendGrid) für E-Mails,Websockets für Echtzeitkommunikation.<br> -Datenanalyse: Tools wie Power BI oder Google Analytics zur Zufriedenheitsüberwachung.</p><p>
 | PRE-1 |
| --- | --- |

| <b>Ingenieurantrag <b> </p><p> -Ein Ingenieurantrag umfasst die Vorbereitung der Unterlagen, das Ausfüllen des Antragsformulars, die Einreichung bei der Behörde, die Prüfung und Genehmigung des Antrags sowie die Dokumentation für zukünftige Referenzen.</p><p> Technologien und Komponenten:<br> -Dokumentenmanagementsystem (DMS): Für die Verwaltung und Archivierung der erforderlichen Unterlagen.<br> -Online-Formularsystem: Zur Eingabe und Übermittlung der Antragdaten.<br> -Behördenportale: Nutzung digitaler Plattformen für die Einreichung.<br> -Projektmanagement-Tool: Zur Nachverfolgung der Bearbeitungsschritte und Fristen.<br> -Kommunikationsplattformen: Für Rückfragen mit Behörden. | PRE-2 |

| <b>Matura & Klassentreffen organisieren</b></p><p> -Die Organisation eines Matura- und Klassentreffens umfasst die Festlegung von Datum und Ort, die Erstellung einer Gästeliste, das Versenden von Einladungen, die Planung des Programms und die Koordination von Verpflegung und Dekoration.</p><p> <b>Technologien und Komponenten:</b><br> -Doodle oder ähnliche Umfragetools: Zur Abstimmung von Datum und Ort.<br>-Excel/Google Sheets: Für die Erstellung und Verwaltung der Gästeliste.<br> -E-Mail-Marketing-Tools: Zum Versenden von Einladungen.<br> -Eventmanagement-Plattformen: Für Programmentwurf und Aufgabenverteilung.<br> -Cloud-basierte Kalender und Tools: Für die Koordination von Verpflegung und Dekoration. | PRE-3 |

## Auswertungen

Mehr Prosa (Unterscheidung Phase 1 & 2)

| <br>Dashboard<br>Frontend:  <br>Anforderung:<br>Das Frontend der Webanwendung soll ein Dashboard bereitstellen, das die letzten Anmeldeaktivitäten des Benutzers anzeigt, schnelle Optionen zur Sicherheitsverwaltung bietet und Benachrichtigungen zu neuen Login-Versuchen ermöglicht. Das Dashboard soll die Benutzerfreundlichkeit und Transparenz im Umgang mit sicherheitsrelevanten Informationen gewährleisten.<br>Beschreibung der Funktionalität:  <br>1. Anzeige der letzten Anmeldeaktivitäten: <br>- Das Dashboard zeigt eine übersichtliche Liste der letzten Anmeldeaktivitäten, einschließlich Datum, Uhrzeit, Gerät/Browser und Standort (basierend auf der IP-Adresse).<br>- Ungewöhnliche oder verdächtige Aktivitäten werden visuell hervorgehoben (z. B. durch farbliche Markierungen oder Warnsymbole). <br>- Eine Funktion zur Markierung von Aktivitäten als „verdächtig“ ermöglicht dem Benutzer, ungewöhnliche Logins direkt zu melden<br>2. Sicherheitsverwaltung:<br>- Das Dashboard enthält direkte Links oder Schaltflächen zu wichtigen Sicherheitsfunktionen, darunter:<br>- Änderung des Passworts<br>- Aktivierung/Deaktivierung der Zwei-Faktor-Authentifizierung (2FA)<br>- Übersicht und Verwaltung aktiver Sitzungen mit der Möglichkeit, einzelne Sitzungen zu beenden<br>- Eine Funktion zur Anzeige und Verwaltung von vertrauenswürdigen Geräten wird bereitgestellt.<br>3. Benachrichtigungen bei neuen Login-Versuchen:<br>- Das Dashboard zeigt Benachrichtigungen zu neuen Login-Versuchen in Echtzeit an, falls diese erkannt werden.<br>- Bei neuen Login-Versuchen aus unbekannten Standorten oder Geräten wird eine zusätzliche Sicherheitsabfrage bereitgestellt (z. B. über E-Mail oder SMS).<br>4. Benutzerfreundlichkeit und Usability:<br>- Die Darstellung der Informationen erfolgt in einem klar strukturierten und leicht verständlichen Format (z. B. Tabellen oder Karten).<br>- Die Sicherheitsoptionen sind intuitiv zugänglich und mit kurzen Erklärungen versehen, um die Benutzerfreundlichkeit zu erhöhen.<br>- Das Design ist responsive und für die Nutzung auf verschiedenen Geräten (Desktop, Tablet, Mobil) optimiert.<br>5. Barrierefreiheit:<br>- Das Dashboard erfüllt Standards zur Barrierefreiheit und unterstützt z. B. Screenreader oder Tastatur-Navigation.<br>- Visuelle Warnhinweise (z. B. zu verdächtigen Aktivitäten) werden durch alternative Texte und Symbole ergänzt<br>Akzeptanzkriterien:<br>- Das Dashboard zeigt die letzten Anmeldeaktivitäten vollständig und korrekt an, einschließlich aller relevanten Details.<br>- Sicherheitsfunktionen wie Passwortänderung, 2FA-Verwaltung und Sitzungsübersicht sind direkt zugänglich und funktionieren einwandfrei.<br>- Benachrichtigungen zu neuen Login-Versuchen werden in Echtzeit angezeigt und ermöglichen eine schnelle Reaktion des Benutzers.<br>- Das Dashboard ist auf verschiedenen Geräten benutzerfreundlich und barrierefrei bedienbar.<br><br>Backend:<br><br>Ein Backend-Dashboard bündelt Systemdaten wie Nutzeraktivität, Serverstatus und Verkaufszahlen in Echtzeit. Es visualisiert KPIs über Diagramme und Tabellen, ermöglicht schnelle Analysen und unterstützt präzise Entscheidungen. Durch Zugriffsrechte und performante Datenbanken bleibt das Dashboard sicher und effizient – die zentrale Kontrollstelle für Systemauswertungen | AUS-1 |
| --- | --- |
| Auswertungen erstellen<br><br>Frontend:  <br>Das System muss präzise Analysen der Anmeldedaten ermöglichen. Dazu gehören die Erfassung und Auswertung der Login-Häufigkeit, die Identifikation verdächtiger Aktivitäten sowie die Bereitstellung von Einblicken in das Nutzerverhalten. Die Ergebnisse sollen in einer übersichtlichen und interaktiven Darstellung visualisiert werden, um eine optimierte Sicherheitsstrategie zu unterstützen.<br><br>Backend:<br><br>Für Auswertungen im Backend sind strukturierte Daten, Filter und Algorithmen zur KPI-Berechnung nötig. Diagramme und Tabellen visualisieren die Ergebnisse. Zugriffsrechte sichern die Daten, eine performante Datenbank sorgt für schnelle Analysen – so werden Rohdaten in präzise Systemauswertungen verwandelt. | AUS-2 |
| Auswertugnen erstellen 2 (Phase 2)<br><br>Frontend:  <br>Das System muss detaillierte Analysen zu Login-Standorten und verwendeten Geräten bereitstellen. Es soll ermöglichen, Zeiträume mit der höchsten Anmeldeaktivität zu identifizieren und potenzielle Sicherheitslücken durch den Vergleich von Nutzeraktivitäten aufzudecken. Zusätzlich müssen detaillierte Statistiken zu fehlgeschlagenen Login-Versuchen sowie häufig genutzten Wiederherstellungsfunktionen erfasst und visualisiert werden, um gezielte Sicherheitsmaßnahmen abzuleiten.<br><br>Backend:<br><br>Für Backend-Auswertungen benötigt man zuverlässige Datenquellen, Filter und Algorithmen zur Berechnung von Metriken. Eine schnelle Datenbank ermöglicht effiziente Verarbeitung, Visualisierungstools wandeln Ergebnisse in Diagramme und Tabellen um. Zugriffsrechte sichern die Daten – so entsteht eine präzise und sichere Analysebasis. | AUS-3 |
| Chart generierung (Phase 2)<br><br>Frontend:  <br>Das System muss eine visuelle Aufbereitung der Anmeldedaten in Form von Charts ermöglichen. Dies umfasst die Darstellung von Login-Zeiten, regionalen Verteilungen sowie der Anzahl erfolgreicher und fehlgeschlagener Anmeldeversuche. Die Visualisierungen sollen eine schnelle Analyse der Nutzeraktivitäten ermöglichen und Trends auf einen Blick erkennbar machen.<br><br>Backend:<br><br>Für die Chart-Generierung im Backend benötigt man Rohdaten, die kontinuierlich aus Datenquellen geladen und gefiltert werden. Algorithmen verdichten diese Daten und bereiten sie in aggregierter Form auf. Eine Charting-Bibliothek übernimmt die Visualisierung und wandelt Daten in Balken-, Linien- oder Kreisdiagramme um. Caching sorgt dabei für Geschwindigkeit, und Zugriffsrechte schützen die Daten. Das Ergebnis: klare, visuell aufbereitete Informationen für schnelle Entscheidungen. | AUS-4 |

## Datenschutz & Informationssicherheit

| **DSGVO-Konform**<br><br>Dass man die Anforderungen der Datenschutz-Grundverordnung (DSGVO) der Europäischen Union erfüllt. Die DSGVO ist eine Verordnung, die darauf abzielt, den Schutz personenbezogener Daten zu stärken und die Kontrolle über die Verwendung und Verarbeitung solcher Daten zurück in die Hände der betroffenen Personen zu legen. | DSc-1 |
| --- | --- |
| **Informationssicherheit**<br><br>Bezeichnet den Schutz von Informationen vor verschiedenen Bedrohungen, um deren Vertraulichkeit, Integrität und Verfügbarkeit zu gewährleisten. Ziel ist es, dass Daten vor unbefugtem Zugriff, Verlust, Missbrauch oder Zerstörung geschützt sind. Alle Daten müssen im Backend geschützt werden. (Serverseitige validierung jedes Requests...) | DSc-2 |

## Schwarzes Brett (Phase 2)

| **Feed**<br><br>Eine Seite auf den Mitteilungen und Ankündigungen gemacht werden. Hier kann man Events anzeigen lassen, Posts anderer Mitglieder usw. | ScB-1 |
| --- | --- |
| **Posten**<br><br>Jeder darf posten, solange ihm in der Vergangenheit dieses Privileg nicht weggenommen wurde. Diese Posts werden dann in dem Feed angezeigt. Ein Post kann eine Sichbarkeitsstufe haben (standardmäßig: öffentlich = jeder angemeldete Benutzer) | ScB-2 |
| **Werbung**<br><br>Firmen können Job Inserate schalten, Diplomarbeitskooperationen anbieten usw. Wir stellen die Schnittstelle für diese Firmen bereit, aber um die Abrechnung muss sich gesondert jemand anderer kümmern | ScB-3 |
| **Meldungsvorgang**<br><br>Man kann unangemessene Inhalte melden, diese Meldungen werden dann von Hand durchgeschaut, ob diese den Regeln widersprechen, und kann dem Benutzer über eine Rollenänderung das Privileg des Postens / Interagieren mit anderen Nutzern auf der Seite entfernt werden. | ScB-4 |

## Anmeldetool für Treffen

| Event erstellen<br><br>Frontend:  <br>Das System muss die Erstellung und Verwaltung sicherheitsrelevanter Events im Zusammenhang mit Anmeldungen ermöglichen. Dazu gehören Erinnerungen zur Passwortaktualisierung sowie Warnmeldungen bei mehrfach fehlgeschlagenen Anmeldeversuchen. Diese Funktionen sollen helfen, sicherheitskritische Ereignisse frühzeitig zu erkennen und präventive Maßnahmen zu ergreifen.<br><br>Backend:<br><br>Für die Event-Erstellung im Anmeldetool-Backend benötigt man eine Eingabemaske, eine Datenbank zur Speicherung der Eventdaten und Algorithmen zur Verwaltung von Anmeldungen. Zugriffsrechte sichern die Bearbeitung, und automatische Bestätigungen erleichtern die Teilnehmerverwaltung. | AfT-1 |
| --- | --- |
| Einladungen verschicken<br><br>Frontend:  <br>Das System ermöglicht die Erstellung und Verwaltung von Events. Administratoren können Events anlegen, Teilnehmer sich anmelden und Benachrichtigungen erhalten. Alle Events und Anmeldungen werden protokolliert.<br><br>Backend:<br><br>Für das Versenden von Einladungen im Backend werden Eventdaten aus der Datenbank abgerufen, personalisierte Einladungen erstellt und per E-Mail oder SMS verschickt. Eine API für den Nachrichtentransport und Zugriffsrechte zur Verwaltung sind notwendig. | AfT-2 |
| Einladung beantworten (zu/absagen)<br><br>Frontend:  <br>Das System muss Nutzern ermöglichen, Einladungen direkt anzunehmen oder abzulehnen. Offene Einladungen sollen zentral verwaltet und der Status jederzeit einsehbar sein. Dies gewährleistet eine sichere und unkomplizierte Verwaltung der Zugangsberechtigungen.<br><br>Backend:<br><br>Für das Beantworten von Einladungen im Backend benötigt man eine Datenbank, um die Teilnahmeantworten (Zusage/Absage) zu speichern. Ein Algorithmus verarbeitet die Rückmeldungen und aktualisiert den Eventstatus. Benachrichtigungen informieren den Organisator über Änderungen, während Zugriffsrechte sicherstellen, dass nur berechtigte Teilnehmer ihre Antwort einreichen können. | AfT-3 |
| Kategorisierung (Phase 2)<br><br>Frontend:  <br>Das System muss eine Kategorisierung der Anmeldetools für Treffen ermöglichen, um eine intuitive und effiziente Nutzung zu gewährleisten. Nutzer sollen zwischen den Optionen „Neue Veranstaltung erstellen“, „An Treffen teilnehmen“ und „Veranstaltungen verwalten“ wählen können. Zudem soll eine übersichtliche Filterung von Veranstaltungen möglich sein, sodass schnell erkennbar ist, wer das Event erstellt hat.<br><br>Backend:<br><br>ür die Kategorisierung im Backend eines Anmeldetools werden Kategorien in der Datenbank definiert und mit den Events verknüpft. Ein Algorithmus ordnet jedes Event der entsprechenden Kategorie zu, basierend auf festgelegten Kriterien. Eine benutzerfreundliche Schnittstelle ermöglicht das Hinzufügen oder Bearbeiten von Kategorien. Zugriffsrechte stellen sicher, dass nur autorisierte Nutzer Änderungen vornehmen können. | AfT-4 |
| Zielgruppenfilter (Phase 2)<br><br>Frontend:  <br>Das System muss einen Zielgruppenfilter für Anmeldetools bereitstellen, der es Nutzern ermöglicht, gezielt Veranstaltungen zu finden, die ihren Interessen entsprechen. Durch intuitive Auswahlmöglichkeiten soll der Zugang zu relevanten Treffen erleichtert werden, sodass passende Optionen schnell entdeckt werden können.<br><br>Backend:<br><br>Für einen Zielgruppenfilter im Backend eines Anmeldetools werden Teilnehmerdaten erfasst und in der Datenbank gespeichert. Ein Algorithmus analysiert diese Daten und filtert Teilnehmer nach festgelegten Kriterien wie Interessen, Demografie oder Eventpräferenzen. Eine benutzerfreundliche Oberfläche ermöglicht das Erstellen und Anpassen von Zielgruppen. Zugriffsrechte sichern die Daten und stellen sicher, dass nur berechtigte Nutzer die Filter anwenden können. | AfT-5 |

## Profilverwaltung

| Profil erstellen <br><br>Frontend:  <br>Das System muss eine Profilverwaltung im Frontend bieten, die es Nutzern ermöglicht, ein individuelles Profil zu erstellen. Nutzer sollen ihre Interessen, Präferenzen sowie persönliche Informationen einfach eingeben können. Zudem sollen sie vergangene Veranstaltungen hinzufügen können, um passende Treffen basierend auf ihren Präferenzen schnell zu finden.<br><br>Backend:<br><br>Für die Profilverwaltung im Backend werden Eingabefelder für persönliche Informationen benötigt, die in einer Datenbank gespeichert werden. Ein Algorithmus validiert die Eingaben und stellt sicher, dass alle erforderlichen Daten korrekt erfasst werden. Zugriffsrechte sichern, dass nur autorisierte Nutzer Profile erstellen können, während eine Schnittstelle das Hinzufügen oder Bearbeiten von Profilen ermöglicht. | Pro-1 |
| --- | --- |
| Profil bearbeiten<br><br>Frontend:  <br>Das System muss eine einfache und benutzerfreundliche Profilbearbeitung im Frontend ermöglichen. Nutzer sollen ihre Informationen schnell und unkompliziert aktualisieren können, einschließlich Interessen, persönlicher Daten und vergangener Veranstaltungen. Die Eingabefelder müssen intuitiv gestaltet sein, sodass Nutzer ihr Profil stets aktuell und relevant halten können.<br><br>Backend:<br><br>Für das Bearbeiten von Profilen im Backend werden Editierfunktionen und eine Datenbank benötigt, die die Änderungen speichert. Ein Algorithmus stellt sicher, dass nur gültige Eingaben übernommen werden. Zugriffsrechte kontrollieren, dass nur autorisierte Nutzer ihre eigenen Profile bearbeiten können. Eine benutzerfreundliche Schnittstelle ermöglicht das einfache Aktualisieren der Profilinformationen. | Pro-2 |
| Profil mit LinkedIn automatisch abgleichen lassen<br><br>Frontend:  <br>Das System muss eine Funktion zum automatischen Abgleich des Profils mit LinkedIn bieten. Durch einen einfachen Klick sollen relevante Daten, wie berufliche Erfahrungen und Interessen, nahtlos übernommen werden. Diese Funktion erleichtert die Erstellung und Aktualisierung des Profils, sodass es stets aktuell und ansprechend bleibt.<br><br>Backend:<br><br>Für den automatischen Abgleich mit LinkedIn wird eine API benötigt, die Profilinformationen aus LinkedIn abruft und in die Datenbank überträgt. Ein Algorithmus aktualisiert die Profildaten entsprechend. Zugriffsrechte stellen sicher, dass nur autorisierte Nutzer den Abgleich durchführen können. | Pro-3 |
| Profil verwaltung<br><br>Frontend:  <br>Das System muss eine benutzerfreundliche Profilverwaltung im Frontend bieten, die es Nutzern ermöglicht, ihre Informationen mühelos zu verwalten. Nutzer sollen persönliche Daten, Interessen und vergangene Veranstaltungen anpassen können, um ein ansprechendes und relevantes Profil zu erstellen. Dieses Profil soll die Teilnahme an zukünftigen Treffen optimieren und eine gezielte Auswahl von relevanten Veranstaltungen erleichtern.<br><br>Backend:<br><br>Für die Profilverwaltung im Backend werden eine Datenbank zur Speicherung der Profildaten, APIs zur Verwaltung und Aktualisierung dieser Informationen sowie Algorithmen zur Validierung der Eingaben benötigt. Eine Benutzeroberfläche ermöglicht das Bearbeiten und Anzeigen der Profile, während Zugriffsrechte sicherstellen, dass nur autorisierte Nutzer auf ihre eigenen Daten zugreifen oder Änderungen vornehmen können. | Pro-4 |

# Datenbank

| Datenbank<br><br>1. Zielsetzung
|Entwicklung einer relationalen Datenbank mit PostgreSQL zur Speicherung und Verwaltung von Anwendungsdaten.<br><br>2. Datenbankdesign<br><br>Datenmodellierung: Erstellung eines konzeptionellen Modells (z.B. ER-Diagramm) zur Definition der Entitäten, Attribute und Beziehungen. Tabellenstruktur: Definition der Tabellen, einschließlich: Primärschlüssel Fremdschlüssel Datentypen für jedes Attribute<br><br>3. Implementierung der Datenbank<br><br>Erstellung der Datenbank: Anlegen der PostgreSQL-Datenbank und der erforderlichen Tabellen. Indizes: Implementierung von Indizes zur Optimierung der Abfragegeschwindigkeit.Constraints: Festlegung von Constraints (z.B. NOT NULL, UNIQUE) zur Gewährleistung der Datenintegrität.<br><br>4. Datenbankanbindung<br><br>Zugriffsmethoden: Definition der Methoden zur Anbindung der Anwendung an die PostgreSQL-Datenbank (z.B. über JDBC, Entity Framework). CRUD-Operationen: Implementierung der grundlegenden CRUD-Operationen (Create, Read, Update, Delete) für die Datenmanipulation.<br><br>5. Sicherheit<br><br>Benutzerverwaltung: Einrichtung von Benutzerrollen und Berechtigungen zur Kontrolle des Zugriffs auf die Datenbank.Datenverschlüsselung: Implementierung von Maßnahmen zur Sicherstellung der Datensicherheit (z.B. SSL-Verbindungen). | DB-1 |
| --- | --- |

# Dokumentation

## Projektdokumentation

| Pflichtenheft | DOK-1 |
| --- | --- |
| Systembeschreibung | DOK-2 |
| Disasterrecovery Handbuch | DOK-3 |
| Benutzer Handbuch | DOK-4 |
| Admin Handbuch | DOK-5 |
| Git Handbuch | Dok-6 |